"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEventTransformResponseResultActionProcessor = exports.askTransformResponseStory = void 0;
const quidproquo_core_1 = require("quidproquo-core");
const awsLambdaUtils_1 = require("../../../../../awsLambdaUtils");
function* askTransformResponseStory({ eventParams, qpqEventRecordResponses: [record], }) {
    if (!record.success) {
        yield* (0, quidproquo_core_1.askLogCreate)(quidproquo_core_1.LogLevelEnum.Fatal, record.error.errorText, record.error.errorStack);
    }
    return {
        statusCode: 500,
    };
}
exports.askTransformResponseStory = askTransformResponseStory;
const getProcessTransformResponseResult = (qpqConfig) => {
    // Create a custom runtime for errored responses so we can log them out
    const errorCustomImplementation = (0, quidproquo_core_1.getProcessCustomImplementation)(qpqConfig, askTransformResponseStory, 'Transform Errored Websocket Response', null, () => new Date().toISOString(), awsLambdaUtils_1.randomGuid);
    return (payload, session, actionProcessors, logger, updateSession, dynamicModuleLoader) => __awaiter(void 0, void 0, void 0, function* () {
        if (payload.qpqEventRecordResponses.some((r) => !r.success)) {
            // We only wan't to run this for errors, because a custom imp is slower then a regular imp
            return yield errorCustomImplementation(payload, session, actionProcessors, logger, updateSession, dynamicModuleLoader);
        }
        return (0, quidproquo_core_1.actionResult)({
            statusCode: 200,
        });
    });
};
const getEventTransformResponseResultActionProcessor = (qpqConfig) => __awaiter(void 0, void 0, void 0, function* () {
    return ({
        [quidproquo_core_1.EventActionType.TransformResponseResult]: getProcessTransformResponseResult(qpqConfig),
    });
});
exports.getEventTransformResponseResultActionProcessor = getEventTransformResponseResultActionProcessor;
